function hw_Class_actionhandler() {
  this.modcount = 0;
  this.state = "";
  this.funcarray = {};
  this.modarray = [];
  this.modnames = {};
  this.tmodarray = [];
}

function hw_exclusiveAction(act, funcname) {
  this.funcarray[act] = funcname;
}

function hw_component(mname, mstring) {
  if (typeof mname == "function") {
    var mtype = "func";
    if (typeof mstring != "undefined")
      this.modnames[mstring] = 1;
  }
  else {
    var mtype = "macro";
    this.modnames[mname] = 1;
  }

  this.modarray[this.modcount] = mname;
  this.tmodarray[this.modcount++] = mtype;
}

function hw_componentExists(mname) {
  return this.modnames[mname] ? true : false;
}

function hw_status(statename) {
  this.state = statename;
}

function hw_dispatch() {
  var funcname;
  var mcount = 0;
  var mmax = this.modarray.length;
  var hact = request.act;
  hact = hact.substring(0, hact.lastIndexOf(".action"));

  if (hact == "custom") {
    customaction();
  }
  else {
    funcname = this.funcarray[hact];
    if (funcname)
      funcname();

    while ((!this.state) && (mcount<mmax)) {
      if (this.tmodarray[mcount] == "func") {
        this.modarray[mcount]();
      }
      else {
        var pageout = place(this.modarray[mcount]);
        if (pageout.constructor == HW_API_Error) {
          hw_retobj = new HW_SSJ_ReturnObject({description:lrc("ahErrCap1", "lib", "Hyperwave Error during evaluating PLACEHOLDERS")});
          hw_retobj.error.append({HW_error:pageout, description:("PLACEHOLDER: " + this.modarray[mcount])});
          break;
        }
        else {
          write(pageout);
        }
      }

      mcount++;
    }
  }

  return this.state;
}

hw_Class_actionhandler.prototype.exclusiveAction = hw_exclusiveAction;
hw_Class_actionhandler.prototype.component = hw_component;
hw_Class_actionhandler.prototype.componentExists = hw_componentExists;
hw_Class_actionhandler.prototype.status = hw_status;
hw_Class_actionhandler.prototype.dispatch = hw_dispatch;


var actionhandler = new hw_Class_actionhandler();

function actionDispatch() { // shortcut to actionhandler.dispatch() for backward compatibility
  actionhandler.dispatch();
}

var errorhandler = new hw_Class_actionhandler();
