function writeFoundObject(obj,noReplace)
{
  if (noReplace) //no replace necessary if HTML is directly written into the page (no var='' around...)
  {
    write(hw_tree_getAnchor(obj,{}));
    write('<img border="0" src="',iconhandler.getIcon(obj),'">');
    writeln('  ',obj.getTitle(),'</a><br>');
  }
  else
  {
    write(hw_tree_getAnchor(obj,{}).replace(/\\/g,'\\\\').replace(/'/g,"\\'"));   //"));
    write('<img border="0" src="',iconhandler.getIcon(obj),'">');
    write('  ',obj.getTitle().replace(/\\/g,'\\\\').replace(/'/g,"\\'"),'</a><br>');   //"));
  }
}

//writes the HTML for the found objects
function writeQueryTrackHTML(p)
{
  var par=p||{};
  var anz=par.numberOfObjectsToGet-0;
  par.startIndex=(par.startIndex-0)||0; //fallback
  var showing=par.showing-0;
  //get the saved query object
  var out=server.object({objectidentifier:par.savedqueryGOid});
  if (out.error.error())
    return {error:out.error};
  var savedquery=out.object;
  //*****execute the Saved Query*****
  out=hw_executeSavedQuery(savedquery,{startIndex:par.startIndex,numberOfObjectsToGet:anz});
  if (out.error.error())
    return {error:out.error};
  var results=out.objects;
  results.sort("-ST",true,client.languages);

  if (results.length==0) //nothing found
    write('<SPAN class=TrackContent>'+lrc("trqDlgTxt2","port","No documents found")+'.</SPAN>');
  else
  {
    //write previous & next buttons
    var buttoncode="parent.window.callServerFunction({serverFunctionName:'fillQueryTrack',callback:'parent.window.newTrackContent_callback(content,container)',parameters:{numberOfObjectsToGet:"+anz+",savedqueryGOid:'"+par.savedqueryGOid+"',trackGOid:'"+par.trackGOid;

    var prevhits=lrc("fqFrmLbl1","port","Previous Hits");
    var nexthits=lrc("fqFrmLbl2","port","Next Hits");

    if (par.startIndex>0) //previous button
    {
      var butcode=buttoncode+"',startIndex:window.top.HW_Mainframe.A"+par.trackGOid+"['"+(showing-anz)+"'],showing:"+(showing-anz)+"}})";
      write('<A HREF="javascript:var out=',(par.noReplace?butcode:butcode.replace(/\'/g,"\\\'")),'"><IMG BORDER=0 SRC="/wavemaster.internal/v1.0/uistyle/hwblue/dialogimg/buttonLeft2.gif" ALT="',prevhits,'"></A>');
    }
    else
      write(imgsp(18,24));

    if (out.more) //next button
    {
      var butcode=buttoncode+"',startIndex:"+out.endIndex+",showing:"+(showing+anz)+"}})";
      write('<A HREF="javascript:var out=',(par.noReplace?butcode:butcode.replace(/\'/g,"\\\'")),'"><IMG BORDER=0 SRC="/wavemaster.internal/v1.0/uistyle/hwblue/dialogimg/buttonRight2.gif" ALT="',nexthits,'"></A>');
    }
    else
      write(imgsp(18,24));
    write('<BR>');

    //display search result entries
    for (var x=0;x<results.length;x++)
      writeFoundObject(results[x],par.noReplace);
  }
  return true;
}

//writes client side code "var queryContentVar='....' and var queryContainerId='...';
function fillQueryTrack(p)
{
  write("var content='"); //beginning of content var
  var out=writeQueryTrackHTML(p);
  if (out.error)
    return {error:out.error};
  writeln("';"); //end of content var
  writeln("var container='",p.trackGOid,"';"); //containerId var
  //save current startIndex into stack for later "previous" searches
  writeln('window.top.HW_Mainframe.A',p.trackGOid,'["',p.showing,'"]="',p.startIndex,'";');
  return true;
}
