//---------------------------------------------------------------
// This file contains menu items for std functions like delete,
// chekin...
// The items can be added to a menu structure with
// menu.addStdFunc(funcname).
// If an item for funcname is not defined no item is added to the
// menustructure.
//---------------------------------------------------------------
function hw_menu_createStdMenuItemsViewMode()
{
  if (typeof HW_MENU_STDFunc!="undefined")
    return;
  var curobj=request.object;

  var curstat = new Object();
  curstat.noEditUser=place("session.user.is_noedituser");
  curstat.editmode=(client.EDIT_MODE=="yes");

  HW_MENU_STDFunc={}
  //--------------------------------------------------------------------------
  // Main Menu bar
  //--------------------------------------------------------------------------
  HW_MENU_STDFunc["hwt_misc_login"]=new MenuItem(lrc("mfMenLbl1","menu","Login"),{act:"_identify",actp:request.unique});

  if (!curstat.noEditUser)
  {
    HW_MENU_STDFunc["hwt_misc_authoring"]=new MenuItem(lrc("mfMenLbl2","menu","Authoring"),{act:"_setlanguage",actp:(curstat.editmode?"EDIT_MODE=no":"EDIT_MODE=yes"),ischecked:curstat.editmode});
  }

  if (place("action") != "parents.action")
    if (place("parents.count") != 0)
    {
      while (place("parents.next_entry")){};
      var aurl="";
      var atarget=null;
      if (place("parents.count")==1 && place("parents.next_entry"))
      {
        if (place("parents.entry.get_attrib","CollectionType") == "AlternativeCluster")
        {
          aurl="%"+"%parents.entry.call(image.action)%"+"%";
        }
        else
        {
          aurl="%"+"%parents.entry.uri%"+"%";
        }
      }
      else
      {
        aurl="%"+"%action.call(parents.action)%"+"%";
        atarget="dialogs";
      }
      HW_MENU_STDFunc["hw_api_parents"]=new MenuItem('<IMG BORDER=0 SRC="/wavemaster.internal/v1.0/uistyle/icons/oneupmenu.gif" WIDTH=15 HEIGHT=13>',{nohighlite:true,url:aurl,target:atarget});
    }
    else
    {
      var spligo=hw_splitGOid(curobj.GOid);
      if (hw_getServerId() != spligo.serv && spligo.oid=="0x00000002") //Remote rootcollection !
      {  
        aurl='/hw_server_pool';
        HW_MENU_STDFunc["hw_api_parents"]=new MenuItem('<IMG BORDER=0 SRC="/wavemaster.internal/v1.0/uistyle/icons/oneupmenu.gif" WIDTH=15 HEIGHT=13>',{nohighlite:true,url:aurl});
      }
    }
}

function hw_menu_createStdMenuItems()
{
  if (typeof HW_MENU_STDFunc!="undefined")
    return;

  var curstat = curstatObj();
  hw_menu_createStdMenuItemsViewMode();
  var curobj=request.object;

//**************************************************************************
// Site Menu
//**************************************************************************
  //  HW_MENU_STDFunc["hwt_sear_search"]=new MenuItem((lrc("mfMenLbl59","menu","Search"))+"...",{key:"S",target:"dialogs",act:"dialog.search"});
  HW_MENU_STDFunc["hwt_misc_changepassword"]=new MenuItem((lrc("mfMenLbl54","menu","Change Password"))+"...",{target:"dialogs",act:"dialog.changepassword",isdisabled:curstat.noEditUser,winstyle:{height:320}});
  //  HW_MENU_STDFunc["hwt_misc_preferences"]=new MenuItem((lrc("mfMenLbl55","menu","Preferences"))+"...",{key:"P",target:"dialogs",act:"dialog.preferences",winstyle:{height:440}});
  HW_MENU_STDFunc["hwt_misc_sethome"]=new MenuItem((lrc("mfMenLbl67","menu","Set User Home")),{act:"setuserhome",operation:"sethome",opobj:true});

  //--------------------------------------------------------------------------
  // Publish menu: submenu cluster
  //--------------------------------------------------------------------------
  HW_MENU_STDFunc["hwt_pub_NewCluster"]=new MenuItem(lrc("mfMenLbl3","menu","Language")+" Cluster...",{target:"dialogs",act:"dialog.newcollection",actp:"Cluster",isdisabled:!curstat.collAndEdit,winstyle:{height:440}});
  HW_MENU_STDFunc["hwt_pub_NewAltCluster"]=new MenuItem("Alternative Cluster...",{target:"dialogs",act:"dialog.newcollection",actp:"Alternative%20Cluster",isdisabled:!curstat.collAndEdit,winstyle:{height:440}});
  HW_MENU_STDFunc["hwt_pub_NewMultCluster"]=new MenuItem("Multi Cluster...",{target:"dialogs",act:"dialog.newcollection",actp:"Multi%20Cluster",isdisabled:!curstat.collAndEdit,winstyle:{height:440}});

//**************************************************************************
// Publish Menu
//**************************************************************************
  HW_MENU_STDFunc["hwt_pub_NewFile"]=new MenuItem((lrc("mfMenLbl4","menu","File"))+"...",{key:"F",target:"dialogs",act:"dialog.uploadfile",isdisabled:!curstat.collAndEdit,winstyle:{height:470}});
  HW_MENU_STDFunc["hwt_pub_NewCollection"]=new MenuItem("Collection...",{key:"C",target:"dialogs",act:"dialog.newcollection",actp:"Collection",isdisabled:!curstat.collAndEdit,winstyle:{height:440}});
  HW_MENU_STDFunc["hwt_pub_NewSequence"]=new MenuItem("Sequence...",{target:"dialogs",act:"dialog.newcollection",actp:"Sequence",isdisabled:!curstat.collAndEdit,winstyle:{height:440}});
  HW_MENU_STDFunc["hwt_pub_NewHTML"]=new MenuItem("HTML...",{key:"Y",target:"dialogs",exec:"HTMLSave=''",act:"dialog.newhtml",isdisabled:!curstat.collAndEdit,winstyle:{minWidth:670}});
  HW_MENU_STDFunc["hwt_pub_NewForum"]=new MenuItem("Forum...",{target:"dialogs",act:"dialog.newforum",isdisabled:!curstat.collAndEdit,winstyle:{height:460}});
  HW_MENU_STDFunc["hwt_pub_NewText"]=new MenuItem("Text...",{key:"T",target:"dialogs",act:"dialog.newtext",isdisabled:!curstat.collAndEdit});
  HW_MENU_STDFunc["hwt_pub_NewNote"]=new MenuItem((lrc("mfMenLbl5","menu","Note"))+"...",{key:"N",target:"newnote",act:"dialog.newnote",isdisabled:curstat.noEditUser});
  HW_MENU_STDFunc["hwt_pub_NewRemote"]=new MenuItem("Remote Document...",{target:"dialogs", act:"dialog.newremotedoc",isdisabled:!curstat.collAndEdit,winstyle:{height:460}});
  if (curstat.isSystem)
    HW_MENU_STDFunc["hwt_pub_NewCGI"]=new MenuItem("CGI...",{target:"dialogs",act:"dialog.newcgi",isdisabled:(!curstat.collAndEdit),winstyle:{height:460}}); //CGI should only be visible for administrators !

//--------------------------------------------------------------------------
// Releaseflow Menu
//--------------------------------------------------------------------------
  HW_MENU_STDFunc["hwt_relf_NewProc"] =new MenuItem((lrc("mfMenLbl6","menu","New Release Procedure"))+"...",{target:"dialogs",act:"dialog.newreleaseflow",isdisabled:"("+!(curstat.isSystem || place("session.user.get_attrib","ReleaseAdmin") != "")+"||nsbform)"});
  HW_MENU_STDFunc["hwt_relf_EditProc"] =new MenuItem((lrc("mfMenLbl7","menu","Edit Release Procedures"))+"...",{target:"dialogs",act:"dialog.selectflow2edit",isdisabled:"("+curstat.noEditUser+"||nsbform)"});
  var relIsDisabledObjStat='(ObjectState("","'+place("session.username.nosystem")+'")||nsbform)'
  if (curstat.isColl)
  {
    HW_MENU_STDFunc["hwt_relf_AssignProc"]=new MenuItem((lrc("mfMenLbl8","menu","Assign Release Procedure"))+"...",{target:"dialogs",act:"assignreleasingobjects",actp:"assign_releasingobjects",op:true,isdisabled:relIsDisabledObjStat});
  }
  else
  {
    HW_MENU_STDFunc["hwt_relf_AssignProc"]=new MenuItem((lrc("mfMenLbl9","menu","Assign Release Procedure"))+"...",{target:"dialogs",act:"assignreleasingobject",opobj:true,isdisabled:"(nsbform)"});
  }
  HW_MENU_STDFunc["hwt_relf_ShowOpenCases"]=new MenuItem(lrc("mfMenLbl10","menu","Show open Cases"),{target:"dialogs",act:"dialog.showopenprocedures",isdisabled:curstat.noEditUser});
  if (curstat.isColl)
  {
    HW_MENU_STDFunc["hwt_relf_CreateCases"]=new MenuItem((lrc("mfMenLbl11","menu","Create Cases"))+"...",{op:true,target:"dialogs",exec:"submitform('CHECKOUT_RELEASINGOBJECTS','dialog.assigncases')",isdisabled:relIsDisabledObjStat});
  }
  else
  {
    HW_MENU_STDFunc["hwt_relf_CreateCases"]=new MenuItem((lrc("mfMenLbl12","menu","Create Cases"))+"...",{op:true,target:"dialogs",exec:"submitform('CHECKOUT_RELEASINGOBJECTS','diaolog.assigncases')",isdisabled:'(checkPublishers()||nsbform)'});
  }

  if (!curstat.isColl || curstat.noEditUser)
  {
    HW_MENU_STDFunc["hwt_relf_StartCase"]=new MenuItem(lrc("mfMenLbl13","menu","Start Case"),{isdisabled:true});
    HW_MENU_STDFunc["hwt_relf_DeleteCase"]=new MenuItem(lrc("mfMenLbl14","menu","Delete Case"),{isdisabled:true});
  }
  else
  {
    var isDisabledObjStatPub='(ObjectState("publish","'+place("session.username.nosystem")+'")||nsbform)';
    HW_MENU_STDFunc["hwt_relf_StartCase"]=new MenuItem(lrc("mfMenLbl15","menu","Start Case"),{act:"message2reviewer",isdisabled:isDisabledObjStatPub});
    HW_MENU_STDFunc["hwt_relf_DeleteCase"]=new MenuItem(lrc("mfMenLbl16","menu","Delete Case"),{act:"cancelflow",isdisabled:isDisabledObjStatPub});
  }
  HW_MENU_STDFunc["hwt_relf_StateOfCase"]=new MenuItem(lrc("mfMenLbl17","menu","Show state of the Case"),{target:"dialogs",act:"dialog.showreleasestate",isdisabled:"("+(!curstat.isColl)+'||ObjectState("any","'+place("session.username.nosystem")+'"))'});

//  Function is not used in the current menu, can be enabled when needed
//  HW_MENU_STDFunc["hwt_relf_CancelCase"]=new MenuItem((lrc("mfMenLbl18","menu","Cancel Case"))+"...",{act:"releasecallback",isdisabled:"("+(!curstat.isColl)+'||ObjectState("waiting","+place("session.username.nosystem")+'")||nsbform)'});

//--------------------------------------------------------------------------
// Version Menu
//--------------------------------------------------------------------------

// Version checkin
  if (curstat.isColl)
  {
    var isdis="("+(curstat.noEditUser || curstat.childrenCount == 0 || curstat.isRemote)+"||nsbform)";
  }
  else
  {
    var isdis="("+(curstat.noEditUser || (curstat.isLocked && !curstat.isVersionControlled) || !curstat.isCheckinable) +"||nsbform)";
  }
  HW_MENU_STDFunc["hw_api_checkIn"]=new MenuItem((lrc("mfMenLbl19","menu","Check In"))+"...",{key:"I",target:"dialogs",act:"dialog.checkin",actmult:"dialog.checkin",actpmult:"multiple",operation:"check_in",opobj:true,isdisabled:isdis});

// Version checkout
  var isdis=true;
  if (curstat.isColl)
  {
    isdis="("+(curstat.noEditUser || curstat.childrenCount == 0 || curstat.isRemote)+"||nsbform)";
  }
  else
  {
    isdis="("+(curstat.noEditUser || (curstat.isLocked && !curstat.isVersionControlled) || !curstat.isCheckoutable) +"||nsbform)";
  }
  if (client.CO_DIALOG=="yes") //display dialog for checkout and one object
    HW_MENU_STDFunc["hw_api_checkOut"]=new MenuItem((lrc("mfMenLbl20","menu","Check Out"))+"...",{key:"O",target:"dialogs",targetmult:"HW_Mainwindow",act:"dialog.checkout",opobj:true,operation:"check_out",namemult:"%"+"%checkout.object.form%"+"%",isdisabled:isdis, winstyle:{minWidth:720}});
  else // perform checkout immediately
    HW_MENU_STDFunc["hw_api_checkOut"]=new MenuItem((lrc("mfMenLbl21","menu","Check Out"))+"...",{key:"O",target:"dialogs",targetmult:"HW_Mainwindow",exec:'submitform("'+place("checkout.object.form")+'","check_out")',isdisabled:isdis, winstyle:{minWidth:720}});

  HW_MENU_STDFunc["hw_api_setCommittedVersion"]=new MenuItem((lrc("mfMenLbl22","menu","Set Committed Version"))+"...",{target:"dialogs",act:"dialog.setcommittedversion",operation:"setv",isdisabled:(!curstat.isColl && !curstat.isVersionControlled || curstat.isRemote),opobj:curstat.isColl, winstyle:{minWidth:720}});
  HW_MENU_STDFunc["hw_api_history"]=new MenuItem((lrc("mfMenLbl23","menu","Version History"))+"...",{key:"V",target:"dialogs",act:"dialog.versionhistory",operation:"vhist",opobj:curstat.isColl,isdisabled:(!curstat.isColl && !curstat.isVersionControlled), winstyle:{minWidth:720}});
  HW_MENU_STDFunc["hw_api_revert"]=new MenuItem((lrc("mfMenLbl24","menu","Revert to Version"))+"...",{key:"R",target:"dialogs", act:"dialog.revertversion",operation:"rhist",isdisabled:(!curstat.isColl && !curstat.isVersionControlled || curstat.isRemote),opobj:curstat.isColl, winstyle:{minWidth:720}});
  HW_MENU_STDFunc["hw_api_freeVersion"]=new MenuItem((lrc("mfMenLbl25","menu","Take Out"))+"...",{target:"dialogs",act:"dialog.freeversion",operation:"freev",isdisabled:(!curstat.isColl && !curstat.isVersionControlled || curstat.isRemote),opobj:curstat.isColl, winstyle:{minWidth:720}});
  HW_MENU_STDFunc["hw_api_removeVersion"]=new MenuItem((lrc("mfMenLbl26","menu","Delete"))+"...",{target:"dialogs", act:"dialog.deleteversion",operation:"delv",isdisabled:(!curstat.isColl && !curstat.isVersionControlled || curstat.isRemote),opobj:curstat.isColl, winstyle:{minWidth:720}});
  HW_MENU_STDFunc["hwt_vers_CheckedOutDocs"]=new MenuItem((lrc("mfMenLbl27","menu","Checked Out Documents"))+"...",{target:"dialogs",act:"dialog.listcheckedout",isdisabled:curstat.noEditUser, winstyle:{minWidth:720}});
  HW_MENU_STDFunc["hw_api_linkVersion"]=new MenuItem((lrc("mfMenLbl28","menu","Create Shortcut"))+"...",{target:"dialogs",operation:"vhist",act:"dialog.versionlinkobject",opobj:curstat.isColl,isdisabled:(!curstat.isColl && !curstat.isVersionControlled || curstat.isRemote), winstyle:{minWidth:720}});

  //--------------------------------------------------------------------------
  // Configuration Management Menu
  //--------------------------------------------------------------------------

  HW_MENU_STDFunc["hw_api_configurationHistory"]=new MenuItem((lrc("mfMenLbl29","menu","History"))+"...",{target:"dialogs",act:"dialog.confighistory",operation:"hconf",opobj:true,isdisabled:Boolean(!curstat.isColl || curstat.isRemote)});
  HW_MENU_STDFunc["hw_api_saveConfiguration"]=new MenuItem((lrc("mfMenLbl30","menu","Save"))+"...",{target:"dialogs",act:"dialog.saveconfiguration",operation:"sconf",opobj:true,isdisabled:(!curstat.isEditable || !curstat.isColl || curobj.CollectionType=="ServColl")});

  HW_MENU_STDFunc["hw_api_mergeConfiguration"]=new MenuItem((lrc("mfMenLbl31","menu","Merge"))+"...",{target:"dialogs",act:"dialog.mergeconfiguration",operation:"cnfmng",opobj:true,isdisabled:(!curstat.isColl || !curstat.isEditable || curobj.CollectionType=="ServColl")});
  HW_MENU_STDFunc["hw_api_restoreConfiguration"]=new MenuItem((lrc("mfMenLbl32","menu","Restore"))+"...",{target:"dialogs",act:"dialog.restoreconfiguration",operation:"cnfmng",opobj:true,isdisabled:(!curstat.isColl || !curstat.isEditable || curobj.CollectionType=="ServColl")});
  HW_MENU_STDFunc["hw_api_removeConfiguration"]=new MenuItem((lrc("mfMenLbl33","menu","Delete"))+"...",{target:"dialogs",act:"dialog.deleteconfiguration",operation:"cnfmng",opobj:true,isdisabled:(!curstat.isColl || !curstat.isEditable || curobj.CollectionType=="ServColl")});

  //--------------------------------------------------------------------------
  // Hyperlink Menu
  //--------------------------------------------------------------------------
  HW_MENU_STDFunc["hwt_hlnk_NewLink"]=new MenuItem((lrc("mfMenLbl34","menu","Add Hyperlink"))+"...",{target:"newlink",act:"dialog.linkwizard",isdisabled:curstat.noEditUser})
  var mlinks=true;
  if (!curstat.noEditUser &&
    curobj.Type == "Document" && curobj.DocumentType != "collection" &&
    curobj.DocumentType != "Remote" && curobj.DocumentType != "CGI")
  {
    if (curobj.DocumentType == "text" && (curobj.MimeType == "text/html" || curobj.MimeType == "text/plain") && curstat.isEditable)
    {
      mlinks=false;
    }
  }
  HW_MENU_STDFunc["hwt_hlnk_ModifyLink"]=new MenuItem((lrc("mfMenLbl35","menu","Modify Hyperlink"))+"...",{target:"dialogs",act:"dialog.modifylinks",isdisabled:mlinks});
  HW_MENU_STDFunc["hwt_hlnk_DeleteLink"]=new MenuItem((lrc("mfMenLbl36","menu","Delete Hyperlink"))+"...",{target:"dialogs",act:"dialog.deletelinks",isdisabled:mlinks});

//**************************************************************************
// Modify Menu
//**************************************************************************
  var edidis=(!curstat.isColl && !curstat.isEditable || curstat.isRemote);
  HW_MENU_STDFunc["hwt_mod_EditAttr"]=new MenuItem((lrc("mfMenLbl37","menu","Attributes"))+"...",{key:"A",target:"dialogs",act:"dialog.editattributes",opobj:true,operation:"mattrib",actmult:"dialog.modifyobjects",isdisabled:edidis});

  HW_MENU_STDFunc["hwt_mod_EditQuery"]=new MenuItem((lrc("stquery","hwrc","Saved Query"))+"...",{target:"dialogs",exec:"top.canceledEditQuery=false",act:"dialog.editquery",actp:"firstcall&"+request.unique,operation:"squery",opobj:true,isdisabled:(!curstat.isColl && !(curstat.isEditable && request.object.ContainerType == "Query") || curstat.isRemote)});

  HW_MENU_STDFunc["hwt_mod_EditText"]=new MenuItem((lrc("mfMenLbl38","menu","Edit Text"))+"...",{target:"dialogs",act:"dialog.edittext",isdisabled:(curstat.noEditUser || !(curobj.DocumentType=="text" && (curobj.MimeType =="text/html" || curobj.MimeType=="text/plain")) || !curstat.isEditable)});

  //HW_MENU_STDFunc[""]=new MenuItem("Hyperlink",{child:hyplM});
  HW_MENU_STDFunc["hwt_mod_EditHTML"]=new MenuItem((lrc("mfMenLbl39","menu","Edit HTML"))+"...",{target:"dialogs",exec:"HTMLSave=''",act:"dialog.editHTML",isdisabled:(curstat.noEditUser || !(curobj.DocumentType=="text" && curobj.MimeType=="text/html") || !curstat.isEditable || curobj.BodyType=="FrameSet" || place("client.agent.name") != "MSIE" || place("client.agent.version.major") <4),winstyle:{minWidth:670}});

  HW_MENU_STDFunc["hw_api_move"]=new MenuItem((lrc("mfMenLbl40","menu","Move"))+"...",{op:true,target:"dialogs",act:"dialog.choosetarget",actp:"move",isdisabled:"("+(curstat.isRemote || !curstat.isEditable || !curstat.editmode)+ '||(typeof move !="function"))'});

  var modifyisdis="("+(curstat.noEditUser || !curstat.editmode)+'|| (typeof move !="function"))';

  HW_MENU_STDFunc["hw_api_link"]=new MenuItem((lrc("mfMenLbl41","menu","Create Shortcut"))+"...",{op:true,target:"dialogs",act:"dialog.choosetarget",actp:"link",isdisabled:modifyisdis});

  HW_MENU_STDFunc["hw_api_copy"]=new MenuItem((lrc("mfMenLbl42","menu","Duplicate"))+"...",{op:true,target:"dialogs",act:"dialog.choosetarget",actp:"copy",isdisabled:modifyisdis});
  //HW_MENU_STDFunc["DuplicateSet"]=new MenuItem(("lrc("mfMenLbl43","menu","Duplicate Set"))+"...",{op:true,target:"dialogs",act:"dialog.choosetarget",actp:"copys",isdisabled:modifyisdis});
  HW_MENU_STDFunc["hw_api_remove"]=new MenuItem(lrc("mfMenLbl44","menu","Delete"),{exec:curstat.action=="userselectionlist.action" || curstat.action=="groupselectionlist.action" || curstat.action=="_insert.attributes.action"?"submitform('selform')":"submitform('"+place("delete.object.form")+"','delete')",isdisabled:"("+(curstat.isRemote || !curstat.isEditable && !(curstat.action=="userselectionlist.action" || curstat.action=="groupselectionlist.action" || curstat.action=="_insert.attributes.action"))+" || nsbform)"});
  HW_MENU_STDFunc["hwt_mod_replace"]=new MenuItem((lrc("mfMenLbl45","menu","Replace"))+"...",{target:"dialogs",operation:"replace",act:"dialog.replace",isdisabled:(curstat.isRemote || !curstat.isColl && !curstat.isEditable),opobj:curstat.isColl});

  if (!curstat.isColl && !curstat.isVersionControlled)
  {
    if (curstat.isLocked)
    {
      HW_MENU_STDFunc["hwt_mod_LockUnlock"]=new MenuItem(lrc("mfMenLbl46","menu","Unlock Object"),{act:"_unlock.object",isdisabled:!curstat.isEditable});
    }
    else
    {
      HW_MENU_STDFunc["hwt_mod_LockUnlock"]=new MenuItem(lrc("mfMenLbl47","menu","Lock Object"),{act:"_lock.object",isdisabled:!curstat.isEditable});
    }
  }
  else
  {
    HW_MENU_STDFunc["hwt_mod_LockUnlock"]=new MenuItem(lrc("mfMenLbl48","menu","Lock/unlock Object"),{isdisabled:true});
  }

  HW_MENU_STDFunc["hwt_menu_clearDCCache"]=new MenuItem(lrc("mfMenLbl60","menu","Clear DC Cache"),{act:"dc.clearcache"});

//**************************************************************************
// View Menu
//**************************************************************************
  HW_MENU_STDFunc["hwt_view_ViewAttr"]=new MenuItem(lrc("mfMenLbl49","menu","Attributes")+"...",{target:"dialogs",act:"dialog.attributes",opobj:true,operation:"vattrib"});
  HW_MENU_STDFunc["hwt_view_LinkMap"]=new MenuItem(lrc("mfMenLbl61","menu","Link Map")+"...",{key:"M",target:"dialogs",act:"dialog.docreferences",opobj:true,operation:"lmap"});
  HW_MENU_STDFunc["hwt_view_SimDocs"]=new MenuItem(lrc("mfMenLbl65","menu","Similar Documents")+"...",{target:"dialogs",act:"dialog.similardocs",opobj:true,operation:"lmap",winstyle:{minWidth:730},isdisabled:place("hyper.ftserver.searchengine.name")!="verity"});
  HW_MENU_STDFunc["hwt_view_HeadFoot"]=new MenuItem(lrc("mfMenLbl62","menu","Header/Footer off"),{url:"%%action.call.query(plain.action)%%",isdisabled:curstat.isColl});
  HW_MENU_STDFunc["hwt_view_Notes"]=new MenuItem(lrc("mfMenLbl63","menu","Notes"),{act:"dialog.notes",target:"dialogs",opobj:true,operation:"vnotes"});

//**************************************************************************
// Admin Menu
//**************************************************************************
  HW_MENU_STDFunc["hwt_admi_newuser"]= new MenuItem((lrc("mfMenLbl50","menu","New User"))+"...",{target:"dialogs",act:"dialog.newuser",isdisabled:curstat.externalUDB});
  HW_MENU_STDFunc["hwt_admi_newgroup"]= new MenuItem((lrc("mfMenLbl51","menu","New Group"))+"...",{target:"dialogs",act:"dialog.newgroup",isdisabled:curstat.externalUDB});
  HW_MENU_STDFunc["hwt_admi_editdeleteUG"]= new MenuItem((lrc("mfMenLbl52","menu","Edit Users and Groups"))+"...",{target:"dialogs",act:"dialog.editdeleteUG",isdisabled:curstat.externalUDB});
  HW_MENU_STDFunc["hwt_admi_assignUG"]= new MenuItem((lrc("mfMenLbl53","menu","Assign Users and Groups"))+"...",{target:"dialogs",act:"dialog.assignUG",winstyle:{minHeight:600}});
  HW_MENU_STDFunc["hwt_admi_serverstatus"]=new MenuItem((lrc("mfMenLbl56","menu","Server Status"))+"...",{target:"dialogs",act:"dialog.serverstatus",isdisabled:!curstat.isSystem});
  HW_MENU_STDFunc["hwt_admi_whoisonline"]=new MenuItem((lrc("mfMenLbl58","menu","Who is online"))+"...",{target:"dialogs",act:"dialog.whoisonline",isdisabled:!curstat.isSystem});
  HW_MENU_STDFunc["hwt_admi_adminpool"]=new MenuItem((lrc("mfMenLbl57","menu","Server Pool"))+"...",{target:"dialogs",act:"dialog.adminpool",isdisabled:!curstat.isSystem});
  HW_MENU_STDFunc["hwt_admi_install"]=new MenuItem((lrc("mfMenLbl68","menu","Install"))+"...",{target:"dialogs",act:"dialog.portal.install",isdisabled:!curstat.isSystem});
  HW_MENU_STDFunc["hwt_admi_logo"]=new MenuItem((lrc("mfMenLbl66","menu","Logo"))+"...",{target:"dialogs",act:"dialog.logo",isdisabled:!curstat.isSystem});
}
